import irc
import BoundIRC
import time
import select
import whrandom
import regsub
import string
import socket
import struct


#
# From when I tried locking...
#
#
try: 
    import thread
except:
    class allocate_lock:
        def acquire(*args): pass
        def release(*args): pass

else:
    class SafeFunction:
        _l=thread.allocate_lock()
        _a=_l.acquire
        _r=_l.release

        def __init__(self, f):
            self._f=f

        def __call__(self, *args, **kw):
            self._a()
            try: return apply(self._f, args, kw)
            finally: self._r()

    allocate_lock=thread.allocate_lock



from threading import Thread, Event

from ZODB.POSException import ConflictError, ExportError
from Sync import Synchronized

# Hrm I think this is bad..
# I should probably ram this inside the class...

CommandEvent=Event()

import Zope

# Keep a list of 'DCC Bots'
dccList=[]


# Try to make sure dcc transfers don't screw us...
# Handles people sending us stuff (doesn't send stuff itself..)

class DCCSendBot:
	def __init__(self, Registry, ChannelId, sender, recip, forum, addl, raw):
		self.sender=sender
		self.recip=recip
		self.forum=forum
		self.addl=addl
		self.raw=raw
		self.ChannelId=ChannelId
		self.Registry=Registry		
		command, args, text = raw
		text=string.strip(text)
		text=text[1:-1] # Strip the ^A's
		ctcp = string.split(text)[0]
		ctcp_args = string.split(text)[1:]
		self.status=0
		zopeobject=self.Registry.getChannel(self.ChannelId)
		u=zopeobject.ThreadMethods.findUser(raw)
		if not u:
			sender.notice('\001DCC REJECT SEND %s\001'%(ctcp_args[1]))
			sender.notice('PERMISSION DENIED')
			return

		self.filename=ctcp_args[1]
		self.ip=self.unmungeIP(long(ctcp_args[2]))
		self.port=int(ctcp_args[3])
		self.file_size=long(ctcp_args[4])

		if hasattr(u, self.filename):
			sender.notice('\001DCC REJECT SEND %s\001'%(ctcp_args[1]))
			sender.notice('FILE EXISTS')
			return
		self.connect(self.ip, self.port)
		self.status = 1 # In Progress
		del zopeobject

	def unmungeIP(self, addr):
		addr_s = ""
		for i in range(4):
			addr_s = "%d.%s" % (addr % 256, addr_s)
			addr = addr / 256
		addr_s = addr_s[:-1]
		return addr_s

	def fileno(self):
		return self.s.fileno()
	
	def connect(self, host, port):
		s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		s.connect((host,port))
		self.s=s
		self.totalBytes=0
		self.data=''

	def handle_input(self):
		tmpData=self.s.recv(self.file_size-self.totalBytes)
		thisBytes=len(tmpData)
		if thisBytes <= 0:
			if self.totalBytes+thisBytes < self.file_size:
				self.status == -1
				self.s.close()
				return
			else:
				self.s.send(struct.pack('l',socket.htonl(self.totalBytes)))
				self.s.close()
				self.status=0 # Complete
				return
		self.totalBytes+=thisBytes
		self.data=self.data+tmpData
		if self.totalBytes >= self.file_size:
			self.s.send(struct.pack('l',socket.htonl(self.totalBytes)))
			self.s.close()
			self.status=0 # Complete
			return
		self.s.send(struct.pack('l',socket.htonl(self.totalBytes)))
			
	def uploadFile(self):
		zopeobject=self.Registry.getChannel(self.ChannelId)
		u=zopeobject.ThreadMethods.findUser(self.raw)
		u.manage_addFile(id=self.filename, file=self.data)

class mybot(BoundIRC.BoundIRC):

	def __init__(self, channel, RegistryId, ChannelId):
		self.initial_channels=[]
		BoundIRC.BoundIRC.__init__(self)

		self.initial_channels.append(channel)
	
		self.bind('001', self.join)
		self.bind('PRIVMSG', self.display_privmsg)		
		self.bind('353', self.do_names) #names
		self.bind('352', self.do_who)   #who
		self.bind('332', self.do_topic) #topic
		self.bind('TOPIC', self.do_topic_set) #topic change..
		self.bind('333', self.do_topic_time) #time topic was set
		self.bind('JOIN', self.do_join)
		self.bind('PART', self.do_part)		
		self.bind('PRIVMSG', self.do_ctcp, '^\001')
		self.bind('MODE', self.do_modes)
		self.bind('NICK', self.do_nick)

		self.RegistryId=RegistryId
		self.channel=channel
		self.ChannelId=ChannelId
		self.app=Zope.app()
		self.Registry=getattr(self.app, self.RegistryId, None)

	def enablePlugins(self):
		zopeobject=self.Registry.getChannel(self.ChannelId)
		zopeobject.ThreadMethods.enablePlugins()


	def addLogEntry(self, name, message):
		zopeobject=self.Registry.getChannel(self.ChannelId)
		zopeobject.ThreadMethods.addLogEntry(name, message)
		

	def join(self, sender, recip, forum, addl, raw):
		for channel in self.initial_channels:
			forum.write_raw("JOIN", channel)

	def display_privmsg(self, sender, recip, forum, addl, raw):
		self.addLogEntry(sender.name(), string.rstrip(addl[0]))

	def act(self, sender, recip, forum, addl, raw):
		forum.ctcp("ACTION", string.join(addl))

	def say(self, sender, recip, forum, addl, raw):
		forum.tell(string.join(addl))

	
	def do_modes(self, sender, recip, forum, addl, raw):
		""" Track Mode Changes """
		command, args, text = raw
		if len(args) < 5:
			# Self modes -- not important
			return

		who = args[0] # The mode changer
		modestring = args[3] # The modes
		victims = args[4:] # The people to whom to apply the modes

		# We should just parse the modes, but, we're going to be lazy..
		# Or parse the who changed the modes and see whether or not to
		# Reverse the modes...
		# This is the simple implementation .. it works poorly for
		# channels that are +p or +s
		for victim in victims:
			forum.write_raw("WHO", victim)

	# CTCP REPLIES Require the sender to be /noticed in reply
	def unmungeIP(self, addr):
		addr_s = ""
		for i in range(4):
			addr_s = "%d.%s" % (addr % 256, addr_s)
			addr = addr / 256
		addr_s = addr_s[:-1]
		return addr_s
	
	def do_ctcp(self, sender, recip, forum, addl, raw):
		""" SED UTC ACTION DCC VERSION CLIENTINFO USERINFO """
		""" ERRMSG FINGER TIME PING ECHO """
		command, args, text = raw
		text=string.strip(text)
		text=text[1:-1] # Strip the ^A's
		ctcp = string.split(text)[0]
		ctcp_args = string.split(text)[1:]
		if ctcp == 'VERSION':
			sender.notice('\001VERSION ZopeBot 0.0.0\001')
			return
		if ctcp == 'ACTION': # We should log actions seperately later
			return
		if ctcp == 'FINGER': # Ignore finger requests
			return
		if ctcp == 'PING':
			ctcp_time=int(ctcp_args[0])
			sender.notice('\001PING %ld %ld\001'%(time.time(), time.time()-ctcp_time))
			return
		if ctcp == 'TIME':
			sender.notice('\001TIME %s\001'%(time.strftime("%Y-%m-%d %H:%M:%S",time.localtime(time.time()))))
			return

		if ctcp == 'DCC' and ctcp_args[0] == 'SEND':
			dccBot=DCCSendBot(self.Registry, self.ChannelId,sender, recip, forum, addl, raw)
			if dccBot.status:
				l = len(dccList)
				dccList.append(dccBot)
				dccBot.index=l
			
	def do_names(self, sender, recip, forum, addl, raw):
		op, args, text=raw
		nicks=string.strip(text)
		for nick in string.split(nicks):
			chanop=0
			ircop=0
			voice=0
			while ( nick[0] not in string.letters and
					nick[0] not in '_[]{}-'):
				if nick[0]=='@':
					chanop=1
				elif nick[0]=='+':
					voice=1
				elif nick[0]=='*':
					ircop=1
				nick=nick[1:]
			foostr='%s'
			if chanop:
				foostr=foostr+' -- opped'
			if voice:
				foostr=foostr+' -- voice'
			if ircop:
				foostr=foostr+' IRC OPERATOR'
			forum.write_raw("WHO",nick)
			continue
		    # print foostr%(nick)
		# print raw

	def do_nick(self, sender, recip, forum, addl, raw):
		op, args, text = raw
		hostmask=args[0]
		nick,hostmask=string.split(hostmask,'!')
		newNick=string.strip(text)

		zopeobject=self.Registry.getChannel(self.ChannelId)
		zopeobject.ThreadMethods.nickChange(nick, newNick)
		
	# We do a who when we join, so we can 'add' users to the Zope List
	# We also cheat on mode change and do it this way...
	def do_who(self, sender, recip, forum, addl, raw):
		op, args, text = raw
		username=string.strip(args[4])
		host=string.strip(args[5])
		nick=string.strip(args[7])
		userFlags=string.strip(args[8])

		zopeobject=self.Registry.getChannel(self.ChannelId)
		zopeobject.ThreadMethods.joinUser(nick, self.channel, username, host, userFlags)
				
	def do_part(self, sender, recip, forum, addl, raw):
		op, args, text = raw
		hostmask=args[0]
		nick,hostmask=string.split(hostmask,'!')
		zopeobject=self.Registry.getChannel(self.ChannelId)		
		zopeobject.ThreadMethods.partUser(nick)

	def do_join(self, sender, recip, forum, addl, raw):
		op, args, text = raw
		hostmask=args[0]
		nick,hostmask=string.split(hostmask,'!')
		forum.write_raw("WHO", nick)
		# forum.write_raw("TOPIC", self.channel)
		#print raw

	def do_topic_set(self, sender, recip, forum, addl, raw):
		op, args, text = raw
		zopeobject=self.Registry.getChannel(self.ChannelId)
		zopeobject.ThreadMethods.setTopic(text)
		zopeobject.ThreadMethods.setTopicTime("%d"%(time.time()),
											  string.split(args[0],'!')[0])
				
		# print raw

	def do_topic(self, sender, recip, forum, addl, raw):
		op, args, text = raw
		zopeobject=self.Registry.getChannel(self.ChannelId)
		zopeobject.ThreadMethods.setTopic(text)
				

	def do_topic_time(self, sender, recip, forum, addl, raw):
		op, args, text = raw
		zopeobject=self.Registry.getChannel(self.ChannelId)
		zopeobject.ThreadMethods.setTopicTime(args[-1], args[-2])
				

	def clearCommandQueue(self):
		zopeobject=self.Registry.getChannel(self.ChannelId)

		while zopeobject.ThreadMethods.hasCommands():
			command=zopeobject.ThreadMethods.getNextCommand()
		
	def checkForCommands(self):
		zopeobject=self.Registry.getChannel(self.ChannelId)		
		while zopeobject.ThreadMethods.hasCommands():
			command=zopeobject.ThreadMethods.getNextCommand()
			if command['command'][0]=='BIND':
				self.bind(command['command'][1],
						  command['command'][2],
						  command['text'])
			elif command['command'][0]=='UNBIND':
				self.unbind(command['command'][1],
							command['command'][2],
							command['text'])
			else: # Raw IRC Command...
				self.write(command['command'], command['text'])
				if command['command'][0]=='QUIT':
					self.app._p_jar.sync()
					self.app._p_jar.close()
					del self.app					
					return 1
		self._p_changed=1

def IrcBot(RegistryId, BotArgs, Channel, ChannelId):
	irc.debug = 1	

	mine = mybot(Channel, RegistryId, ChannelId)
	server, port, nick, name=BotArgs
	mine.connect(server, port, nick, name)
	#mine.clearCommandQueue() # Clear any persistent commands that might be lingering
	try:
		# Wait for connection first...
		inready, outready, ignored = select.select([mine], [], [])
		for i in inready:
			i.handle_input()

		# If it takes more than .25 seconds to get some input, we must be
		# connected and inside the channel...
		while 1:
			still_processing=0
			inready, outready, ignored = select.select([mine], [], [], 0.25)
			for i in inready:
				still_processing=1
				i.handle_input()
			if not still_processing:
				break
		mine.enablePlugins()
		# Ok we're settled now, just loop around doing stuff...
		while 1:
			inready, outready, ignored = select.select([mine], [], [], 0.25)
			if inready:
				for i in inready:
					i.handle_input()

			CommandEvent.wait(0.25)										
			if CommandEvent.isSet():
				quit=0
				try:
					quit=mine.checkForCommands()
					CommandEvent.clear()					
				except ConflictError: # Might change while we're checking...
					pass # Come back later and try again
				if quit:
					return
			if dccList:
				inready, outready, ignored = select.select(dccList, [], [], 0.25)
				if inready:
					for i in inready:
						i.handle_input()
						if not i.status:
							i.uploadFile()
							del dccList[i.index]
						if i.status < 0:
							del dccList[i.index]
						
						

				
	except:
		mine.write(["QUIT",], "Shit Happened")
		print "We're exiting -- %s"%(nick)
		import traceback
		traceback.print_exc()
		return


# This thread fires off all the rest of the threads...
def BotRunner(RegistryId, RegistryChange):
	CurrentBots={}

	# Fire off all the bots...
	# We can't actually do this yet since the other object might not
	# have woken up yet...

	import Zope
	app=Zope.app()
	Registry=getattr(app, RegistryId,None)
	
	for bot in Registry.getIRCBots().keys():
		thisChannel=Registry.getChannel(bot)
		args=thisChannel.ThreadMethods.getBotArgs()
		channel=thisChannel.ThreadMethods.getChannel()
		
		botThread = Thread(target=IrcBot,
						   name='IrcBot for %s'%(channel),
						   args=(RegistryId, args, channel, bot))
		botThread.setDaemon(1) # Kill when zope dies
		botThread.start()
		CurrentBots[bot]=botThread
	app._p_jar.sync()
	app._p_jar.close()
	del app
	
	while 1:
		interval=900.0 #Sleep 15 minutes... we only start and stop things..
		
		RegistryChange.wait(interval)

		if RegistryChange.isSet():
			RegistryChange.clear()
			app=Zope.app()
			Registry=getattr(app, RegistryId,None)

			# Kill Deleted Bots
			for bot in CurrentBots.keys():
				if bot not in Registry.getIRCBots().keys():
					print "deleting bot: %s"%(bot)
					CurrentBots[bot].join()
					CurrentBots[bot]._Thread__delete()
					del CurrentBots[bot]

			# Start New Bots
			for bot in Registry.getIRCBots().keys():
				if bot not in CurrentBots.keys():
					thisChannel=Registry.getChannel(bot)
					args=thisChannel.ThreadMethods.getBotArgs()
					channel = thisChannel.ThreadMethods.getChannel()
					botThread = Thread(target=IrcBot,
									   name='IrcBot for %s'%(channel),
									   args=(RegistryId, args, channel, bot))
					botThread.setDaemon(1) # Kill when zope dies
					botThread.start()
					CurrentBots[bot]=botThread
					
			app._p_jar.sync()
			app._p_jar.close()
			del app
